import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'achieveApply' },
})
export class AchieveApply extends BaseModel {
  @prop({ required: false, index: true, zh: '用户id' })
  user_id: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：achieve_apply_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: true, zh: '成果编号' })
  num: string;
  @prop({ required: false, index: true, zh: '成果名称' })
  name: string;
  @prop({
    required: false,
    index: false,
    zh: '成果类型',
    remark: '字典表：achieve_apply_type',
  })
  type: Array<any>;
  @prop({
    required: false,
    index: false,
    zh: '成果形式',
    remark: '字典表：achieve_apply_form',
  })
  form: Array<any>;
  @prop({ required: false, index: true, zh: '成果取得时间' })
  get_time: string;
  @prop({ required: false, index: true, zh: '申请人' })
  apply_personal: string;
  @prop({ required: false, index: true, zh: '申请人手机号' })
  apply_phone: string;
  @prop({ required: false, index: true, zh: '申请人单位' })
  apply_company: string;
  @prop({ required: false, index: true, zh: '联系地址' })
  apply_address: string;
  @prop({
    required: false,
    index: true,
    zh: '申请人/申请单位属性',
    remark: '字典表：achieve_apply_nature',
  })
  apply_nature: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '传真' })
  fax: string;
  @prop({
    required: false,
    index: false,
    zh: '评价目的',
    remark: '字典表：achieve_apply_objective',
  })
  objective: string;
  @prop({
    required: false,
    index: false,
    zh: '成果所处阶段',
    remark: '字典表：achieve_apply_stage',
  })
  stage: string;
  @prop({ required: false, index: false, zh: '成果的影响及作用' })
  influence: string;
  @prop({
    required: false,
    index: false,
    zh: '经济效益',
    remark:
      '经济效益产值output，经济效益利润profit，经济效益税收revenue，社会效益shxy',
  })
  benefit: object;
  @prop({
    required: false,
    index: false,
    zh: '其他信息',
    remark: '吉发号jfh，第几号num，签字sign，所在地address，邮编yb，隶属ls',
  })
  other: object;
  @prop({
    required: false,
    index: false,
    zh: '参加单位',
    remark:
      '参加单位1one_name,参加单位1所在地one_address,参加单位2two_name,参加单位2所在地two_address',
  })
  part_company: object;
  @prop({
    required: false,
    index: false,
    zh: '国家奖励',
    remark: '国家奖励项num,国家奖励名称name,国家奖励等级grade',
  })
  gj_reward: object;
  @prop({
    required: false,
    index: false,
    zh: '省级奖励',
    remark: '省级奖励项num,省级奖励名称name,省级奖励等级grade',
  })
  sj_reward: object;
  @prop({
    required: false,
    index: false,
    zh: '国家计划',
    remark: '国家计划项num，国家计划经费money',
  })
  gj_plan: object;
  @prop({
    required: false,
    index: false,
    zh: '省级计划',
    remark: '省级计划项num，省级计划经费money',
  })
  sj_plan: object;
  @prop({
    required: false,
    index: false,
    zh: '内容简介',
    remark:
      '  成果简介：blurb     应用领域和技术原理：field     性能指标：kpi_index     与国内外同类技术比较：compare     成果的创造性，先进性：advanced     作用意义：sense【string】     推广应用的范围，条件和前景：prospect     存在的问题和改进意见：opinion',
  })
  brief: object;
  @prop({
    required: false,
    index: false,
    zh: '主研人员名单',
    remark:
      ' 姓名：name    性别：gender    身份证号：card    出生年月日：birth    年龄：age    手机号：phone    电子邮箱：email    文化程度：education    学位：degree    从事专业：major    职务：zw    职称：zc    工作单位：company    是否留学归国：is_abroad    项目中所承担的主要工作：work    对成果创造性贡献：devote',
  })
  research: Array<any>;
  @prop({
    required: false,
    index: false,
    zh: '委托方提供资料清单',
    remark:
      '工作报告(必备)：work   技术报告(必备)：techol   国内外对比报告(必备)：compare   经济效益分析(必备)：benefit   科技查新报告(必备)：science   技术检测报告：detect   用户证明：prove   专利证书：patetncert   软件著作权：software   论文：treatise   工法：gf   企业标准等证明材料：standard',
  })
  data_list: object;
  @prop({
    required: false,
    index: false,
    zh: '其他文件',
    remark:
      '现场测试（检测，测产）意见：scene 评价意见：desc 评价专家组名单：nameList',
  })
  other_file: object;
}
