import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'achieveExpert' },
})
export class AchieveExpert extends BaseModel {
  @prop({ required: false, index: true, zh: '用户类型', default: '11' })
  type: string;
  @prop({ required: false, index: true, zh: '角色' })
  role: Array<any>;
  @prop({ required: false, index: true, zh: '专家id' })
  expert_id: string;
  @prop({ required: false, index: true, zh: '专家姓名' })
  expert_name: string;
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '工作单位' })
  company: string;
  @prop({ required: false, index: true, zh: '评价专家组职务' })
  group_zw: string;
  @prop({ required: false, index: true, zh: '所学专业' })
  major: string;
  @prop({ required: false, index: true, zh: '现从事专业' })
  on_major: string;
  @prop({ required: false, index: true, zh: '职务' })
  zw: string;
  @prop({ required: false, index: true, zh: '职称' })
  zc: string;
  @prop({ required: false, index: true, zh: '状态', default: '1' })
  status: string;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
}
