import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'expertExam' },
})
export class ExpertExam extends BaseModel {
  @prop({ required: false, index: true, zh: '专家id' })
  achieveexpert_id: string;
  @prop({ required: false, index: true, zh: '专家姓名' })
  expert_name: string;
  @prop({ required: false, index: true, zh: '成果申请id' })
  apply_id: string;
  @prop({ required: false, index: true, zh: '成果申请名称' })
  apply_name: string;
  @prop({
    required: false,
    index: true,
    zh: '工作类型',
    remark: '字典表：achieve_expertexam_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '分数' })
  score: string;
  @prop({ required: false, index: false, zh: '意见' })
  desc: string;
  @prop({
    required: false,
    index: true,
    zh: '是否评分',
    remark: '字典表：common_isno',
    default: '1',
  })
  is_score: string;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
}
