import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_achieveExpert {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '专家id' })
  'expert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  'expert_name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'company': string = undefined;
  @ApiProperty({ description: '评价专家组职务' })
  'group_zw': string = undefined;
  @ApiProperty({ description: '所学专业' })
  'major': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  'on_major': string = undefined;
  @ApiProperty({ description: '职务' })
  'zw': string = undefined;
  @ApiProperty({ description: '职称' })
  'zc': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QDTO_achieveExpert extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'type',
      'role',
      'expert_id',
      'expert_name',
      'account',
      'phone',
      'company',
      'group_zw',
      'major',
      'on_major',
      'zw',
      'zc',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '专家id' })
  'expert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  'expert_name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'company': string = undefined;
  @ApiProperty({ description: '评价专家组职务' })
  'group_zw': string = undefined;
  @ApiProperty({ description: '所学专业' })
  'major': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  'on_major': string = undefined;
  @ApiProperty({ description: '职务' })
  'zw': string = undefined;
  @ApiProperty({ description: '职称' })
  'zc': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_achieveExpert extends FVO_achieveExpert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_achieveExpert {
  @ApiProperty({ description: '用户类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
  @ApiProperty({ description: '专家id' })
  @Rule(RuleType['string']().empty(''))
  'expert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  @Rule(RuleType['string']().empty(''))
  'expert_name': string = undefined;
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '工作单位' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '评价专家组职务' })
  @Rule(RuleType['string']().empty(''))
  'group_zw': string = undefined;
  @ApiProperty({ description: '所学专业' })
  @Rule(RuleType['string']().empty(''))
  'major': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  @Rule(RuleType['string']().empty(''))
  'on_major': string = undefined;
  @ApiProperty({ description: '职务' })
  @Rule(RuleType['string']().empty(''))
  'zw': string = undefined;
  @ApiProperty({ description: '职称' })
  @Rule(RuleType['string']().empty(''))
  'zc': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_achieveExpert extends FVO_achieveExpert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_achieveExpert extends CDTO_achieveExpert {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_achieveExpert extends FVO_achieveExpert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '专家id' })
  'expert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  'expert_name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'company': string = undefined;
  @ApiProperty({ description: '评价专家组职务' })
  'group_zw': string = undefined;
  @ApiProperty({ description: '所学专业' })
  'major': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  'on_major': string = undefined;
  @ApiProperty({ description: '职务' })
  'zw': string = undefined;
  @ApiProperty({ description: '职称' })
  'zc': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
