import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_certFile {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '申请id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '申请人姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '证书资料' })
  'cert_file': Array<any> = undefined;
  @ApiProperty({ description: '上传时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QDTO_certFile extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'user_id',
      'user_name',
      'apply_id',
      'apply_name',
      'create_time',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '申请id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '申请人姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '上传时间' })
  'create_time': string = undefined;
}

export class QVO_certFile extends FVO_certFile {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_certFile {
  @ApiProperty({ description: '申请id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '申请人姓名' })
  @Rule(RuleType['string']().empty(''))
  'user_name': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  @Rule(RuleType['string']().empty(''))
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  @Rule(RuleType['string']().empty(''))
  'apply_name': string = undefined;
  @ApiProperty({ description: '证书资料' })
  @Rule(RuleType['array']().empty(''))
  'cert_file': Array<any> = undefined;
  @ApiProperty({ description: '上传时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_certFile extends FVO_certFile {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_certFile extends CDTO_certFile {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_certFile extends FVO_certFile {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
