import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_examLogs {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '审核人id' })
  'exam_id': string = undefined;
  @ApiProperty({ description: '审核人姓名' })
  'exam_name': string = undefined;
  @ApiProperty({ description: '审核人手机号' })
  'exam_phone': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '审核步骤' })
  'step': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'status': string = undefined;
  @ApiProperty({ description: '审核意见' })
  'desc': string = undefined;
  @ApiProperty({ description: '审核时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QDTO_examLogs extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'exam_id',
      'exam_name',
      'exam_phone',
      'apply_id',
      'apply_name',
      'step',
      'status',
      'create_time',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '审核人id' })
  'exam_id': string = undefined;
  @ApiProperty({ description: '审核人姓名' })
  'exam_name': string = undefined;
  @ApiProperty({ description: '审核人手机号' })
  'exam_phone': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '审核步骤' })
  'step': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'status': string = undefined;
  @ApiProperty({ description: '审核时间' })
  'create_time': string = undefined;
}

export class QVO_examLogs extends FVO_examLogs {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_examLogs {
  @ApiProperty({ description: '审核人id' })
  @Rule(RuleType['string']().empty(''))
  'exam_id': string = undefined;
  @ApiProperty({ description: '审核人姓名' })
  @Rule(RuleType['string']().empty(''))
  'exam_name': string = undefined;
  @ApiProperty({ description: '审核人手机号' })
  @Rule(RuleType['string']().empty(''))
  'exam_phone': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  @Rule(RuleType['string']().empty(''))
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  @Rule(RuleType['string']().empty(''))
  'apply_name': string = undefined;
  @ApiProperty({ description: '审核步骤' })
  @Rule(RuleType['string']().empty(''))
  'step': string = undefined;
  @ApiProperty({ description: '审核状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '审核意见' })
  @Rule(RuleType['string']().empty(''))
  'desc': string = undefined;
  @ApiProperty({ description: '审核时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_examLogs extends FVO_examLogs {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_examLogs extends CDTO_examLogs {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_examLogs extends FVO_examLogs {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
