import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_expertExam {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '专家id' })
  'achieveexpert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  'expert_name': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '工作类型' })
  'type': string = undefined;
  @ApiProperty({ description: '分数' })
  'score': string = undefined;
  @ApiProperty({ description: '意见' })
  'desc': string = undefined;
  @ApiProperty({ description: '是否评分' })
  'is_score': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QDTO_expertExam extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'achieveexpert_id',
      'expert_name',
      'apply_id',
      'apply_name',
      'type',
      'is_score',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '专家id' })
  'achieveexpert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  'expert_name': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '工作类型' })
  'type': string = undefined;
  @ApiProperty({ description: '是否评分' })
  'is_score': string = undefined;
}

export class QVO_expertExam extends FVO_expertExam {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_expertExam {
  @ApiProperty({ description: '专家id' })
  @Rule(RuleType['string']().empty(''))
  'achieveexpert_id': string = undefined;
  @ApiProperty({ description: '专家姓名' })
  @Rule(RuleType['string']().empty(''))
  'expert_name': string = undefined;
  @ApiProperty({ description: '成果申请id' })
  @Rule(RuleType['string']().empty(''))
  'apply_id': string = undefined;
  @ApiProperty({ description: '成果申请名称' })
  @Rule(RuleType['string']().empty(''))
  'apply_name': string = undefined;
  @ApiProperty({ description: '工作类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '分数' })
  @Rule(RuleType['string']().empty(''))
  'score': string = undefined;
  @ApiProperty({ description: '意见' })
  @Rule(RuleType['string']().empty(''))
  'desc': string = undefined;
  @ApiProperty({ description: '是否评分' })
  @Rule(RuleType['string']().empty(''))
  'is_score': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_expertExam extends FVO_expertExam {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_expertExam extends CDTO_expertExam {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_expertExam extends FVO_expertExam {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
