import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import {
  BaseService,
  FrameworkErrorEnum,
  ServiceError,
} from 'free-midway-component';
import { AchieveExpert } from '../entity/achieveExpert.entity';
import { LoginDTO } from '../interface/achieveExpert.interface';
import isEqual = require('lodash/isEqual');
type modelType = ReturnModelType<typeof AchieveExpert>;
@Provide()
export class AchieveExpertService extends BaseService<modelType> {
  @InjectEntityModel(AchieveExpert)
  model: modelType;

  async findUserToLogin(data: LoginDTO): Promise<object> {
    const { account, password } = data;
    const user = await this.model.findOne({ account }, '+password').lean();
    if (!user)
      throw new ServiceError(
        '未找到会审专家信息',
        FrameworkErrorEnum.NOT_FOUND_DATA
      );
    if (!isEqual(user.password.secret, password))
      throw new ServiceError('密码错误', FrameworkErrorEnum.SERVICE_FAULT);
    return user;
  }
}
